﻿------------------------------------------------------------------------------------------
--Cooldown Group Frame--------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local IsAddOnLoaded = IsAddOnLoaded
local IsInRaid = IsInRaid
local UnitInParty = UnitInParty
local UnitInRaid = UnitInRaid
local UnitGUID = UnitGUID
local GetInspectSpecialization = GetInspectSpecialization
local GetNumGroupMembers = GetNumGroupMembers
local GetSpellCooldown = GetSpellCooldown
local IsInInstance = IsInInstance
local pairs = pairs
local unpack = unpack

function SN:SetupCD()

	F.cooldowns = T:NewGroup(SN.data.profile.cooldown.width, "CD Frame", cooldowns, M.media.draghandle)
	F.cooldowns:SetSorting("SN:arg4")
	if(IsAddOnLoaded("ElvUI")) then
		F.cooldowns:SetSpacing(0, 3)
		F.cooldowns:SetStartPoint(SN.data.profile.cooldown.elvgrow)
		F.cooldowns:SetPoint(unpack(SN.data.profile.frames.elvcooldowns))
	else
		F.cooldowns:SetSpacing(0, 3)
		F.cooldowns:SetStartPoint(SN.data.profile.cooldown.grow)
		F.cooldowns:SetPoint(unpack(SN.data.profile.frames.cooldowns))
	end
	F.cooldowns:SetScript("OnEvent", function(self, event, ...)
		SN:CooldownEvents(self, event, ...)
	end)
	
	--Register our events for the frame
	F.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.cooldowns:RegisterEvent("PLAYER_REGEN_DISABLED")
	F.cooldowns:RegisterEvent("SPELL_UPDATE_USABLE")
end

function SN:CooldownEvents(self, event, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellId, spellName = select(12, ...)
				
		if type == "SPELL_CAST_SUCCESS" then
			if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
				for i, cooldown in pairs(SN.data.profile.cooldowns) do
					if spellId == cooldown.id then
						if cooldown.enable then
						--Check to see if the cd is a personal only and also if it is enable
							if SN.data.profile.cooldown.raid then
								if UnitInParty(sourceName) or UnitInRaid(sourceName) then -- or (sourceGUID == UnitGUID("player")) then
									--SN:Debug(frame.name)
									local modCD
									local unit = SN:GUIDToUnitID(sourceGUID)
									if spellId == 740 and GetInspectSpecialization(unit) == 105 then
										modCD = 180
									else
										modCD = cooldown.CD
									end
									SN:CreateBar(self, spellId, modCD, sourceName, sourceGUID, spellName, 
										SN.data.profile.cooldown.width, SN.data.profile.cooldown.height, SN.data.profile.cooldown.fontsize, LSM:Fetch("font", SN.data.profile.cooldown.font),
												LSM:Fetch("statusbar", SN.data.profile.cooldown.texture))
										
									local bit
									if GetNumGroupMembers() > 5 and IsInRaid() then
										bit = true
									elseif GetNumGroupMembers() > 1 and not IsInRaid() then
										bit = false
									end
									SN:Announcer(self, modCD, spellId, sourceName, destName, bit)
								end
							elseif sourceGUID == UnitGUID("player") then
								local modCD
								local unit = SN:GUIDToUnitID(sourceGUID)
								if spellId == 740 and GetInspectSpecialization(unit) == 105 then
									modCD = 180
								else
									modCD = cooldown.CD
								end
								if sourceGUID == UnitGUID("player") and cooldown.class == SN.playerClass then
									SN:CreateBar(self, spellId, modCD, sourceName, sourceGUID, spellName, 
										SN.data.profile.cooldown.width, SN.data.profile.cooldown.height, SN.data.profile.cooldown.fontsize, LSM:Fetch("font", SN.data.profile.cooldown.font),
												LSM:Fetch("statusbar", SN.data.profile.cooldown.texture))
								end
							end
						end
					end
				end
			end
		elseif type == "UNIT_DIED" or "UNIT_DESTROYED" then
		--Check for a wipe so we can kill the cooldown bars
			local inInstance, instanceType = IsInInstance()
			if (inInstance and instanceType == "raid" or "party") and GetNumGroupMembers() > 1 then
				local wiped = SN:CheckForWipe()
				if wiped then
					for i, bar in pairs(self.bars) do
						if i:GetData("SN:arg7") > 299 then
							i:Stop()
						end
					end
				end
			end
		end
	end
	if event == "SPELL_UPDATE_USABLE" then
			
		local i = self:Find("SN:arg4", "player")
		if i ~= nil then
			local _, duration, enable = GetSpellCooldown(i:Get("SN:arg2"))
			if duration == 0 then
				i:Stop()
			end
		end
	end
end

function SN:GUIDToUnitID(guid)
	local prefix, min, max = "Raid", 1, GetNumGroupMembers()
	-- Prioritise getting direct units first because other players targets
	-- can change between notify and event which can bugger things up
	for i = min, max do
		local unit = i == 0 and "player" or prefix .. i
		if (UnitGUID(unit) == guid) then
			return unit
		end
	end
	
	if(guid == UnitGUID("player")) then
		return "player"	
	end

	-- This properly detects target units
	if (UnitGUID("target") == guid) then
        return "target"
	elseif (UnitGUID("focus") == guid) then
		return "focus"
	elseif (UnitGUID("mouseover") == guid) then
		return "mouseover"
    end

	for i = min, max + 3 do
		local unit
		if i == 0 then
			unit = "player"
		elseif i == max + 1 then
			unit = "target"
		elseif i == max + 2 then
			unit = "focus"
		elseif i == max + 3 then
			unit = "mouseover"
		else
			unit = prefix .. i
		end
		if (UnitGUID(unit .. "target") == guid) then
			return unit .. "target"
		elseif (i <= max and UnitGUID(unit.."pettarget") == guid) then
			return unit .. "pettarget"
		end
	end
	return nil
end